# monolish: MONOlithic LIner equation Solvers for Highly-parallel architecture. {#mainpage}

## Past versions
- [0.14.1](https://ricosjp.github.io/monolish/0.14.1/)
- [0.14.0](https://ricosjp.github.io/monolish/0.14.0/)

## For users:
- [What's monolish?](@ref monolish_intro)
- Installation
  - [Installation using apt (for ubuntu 20.04 and 20.10)](@ref install_guide)
  - [Docker container with monolish installed](@ref monolish_docker)
- [Data types](@ref data_type)
- [Compile and run simple program on CPU](@ref cpu_dev)
- [GPU device acceleration](@ref gpu_dev)
- [Matrix/vector operations](@ref oplist)
- [Linear solvers](@ref solverlist)
- [Performance logging and find bottlenecks](@ref logger)
- [View continuous benchmarking results](https://ricosjp.github.io/monolish_benchmark_result/)

## For developpers:
- [Build monolish from source code](@ref build_guide)
- [Testing and Benchmarking](@ref test_bench)
- [Contribution guide](@ref contribution) 

## Meta information:
- [Source code](https://github.com/ricosjp/monolish/)
- [Documentation](https://ricosjp.github.io/monolish/)
- [Bug reports](https://github.com/ricosjp/monolish/issues)
- [Releases](https://github.com/ricosjp/monolish/releases)
- [Changelog](https://github.com/ricosjp/monolish/blob/master/CHANGELOG.md)
- [Lisence](https://github.com/ricosjp/monolish/blob/master/LICENSE)
- [monolish log viewer](https://pypi.org/project/monolish-log-viewer/)


Copyright 2021 [RICOS Co. Ltd.](https://www.ricos.co.jp/)
